\chapterpic{\resizebox{\textwidth}{!}{
%    \epsfig{width=\linewidth,file=fig/communication_between_modules}
    \epsfig{width=\linewidth,file=ink/layers}
}}
  {The 3 layers sorted in order to show how the system operates
    together with the physical layer.}
\chapter{Communication}
In this chapter, I will take a look at the basic communcation
and some of the methods I will use for describing the details in
the different algorithms. I will provide basic figures and basic
terminology that is similar to the ones used later in the
report.

Furthermore, the Odin structure in the communication domain is
not a completely straightforward graph structure. Therefore this
will try to explain these differences which hopefully will aid
in understanding the different algorithms.

Finally, before digging in to the actual communication layers, I
will give a short description of how randomness is to be
understood in this chapter. The reason why it is placed here is
because every layer has some need for a randomized function.

\paragraph{Conventions}
During the remainder pages of this report, i will use the term
\emph{module} as a replacement for the \emph{link module} and
\emph{node} as a replacement for the \emph{node module}. Next,
each of the communicating ends of the link modules will be
refered to as a \emph{terminator}.



\section{Understanding the network}
In order to understand the basics of the network, it is
essential to take a short view on how a network is composed as a
series of nodes and modules.

Each module in its basic form, communicates through the two
terminators coupled through a node that gives it the possibility
to communicate to a series of other modules in this net. The
terminal end participates with all the other modules single
terminator ends and therefore can be considered to be part of a
single subnet structure. This structure forms a local fully
connected graph ((c) in figure \ref{fig:com_between_modules})
and therefore everyone will hear what is being said at the same
time. In this form it can be visualized as a local network where,
in order to send messages to another network, it must be routed
through one of the other modules in order to jump from net to
net.

This means that we can consider connectivity, package delivery
and collision for one subnet at a time which provides us with
two approaches in the communication paradigm: Either talking in
one node net at the time or considering the communication
between these node nets.

\begin{Figure}[H]
\centering
\centering\epsfig{file=fig/communication_between_modules}
\caption[Comunication between links and modules]{On the right is
  shown how the modules are connected to other modules through
  nodes. This can be transferred to a graph structure where the
  module is connected to two other subgraphs as
  well.}  \label{fig:com_between_modules} \end{Figure}

\section{Terminology}
In order to describe the different algorithmic ideas, I intend
to describe the individual methods using state machines. I could
have used the term \emph{Non-deterministic Finite Automata}
(NFA), but working in such terms imposes a larger series of
demands for describing the individual terms of the model. I will
however, give a short introduction to the description of a state
machine as I intend to use it.

Figure \ref{fig:basic_statemachine} visualizes a basic
statemachine as I use it in this report. The state
machine consists of the states $S_{1\ldots n}$ and the
transition actions $A_{1\ldots n-1}$.

The translations between the states $S_{1 \ldots n}$ is
generally executed by either sending or recieving a message
to/from the other nodes in the system. That means that the
actions $A_{1\ldots n-1}$ are performed in each round by either
the reception or sending of a single message
($R^{\leftarrow/\rightarrow}_k(m)$ or
$T^{\leftarrow/\rightarrow}_k(m)$). The arrows indicate if the
action is performed on the relative forward ($A^{\rightarrow}$)
or backward ($A^{\leftarrow}$) interface. 

The transition format can be either of the two forms.

\begin{sidefig}
%\centering
\begin{pspicture}(4,6)
  %\psframe*[linecolor=blueback](4,4){}
  \psset{linecolor=black,fillcolor=white,nodesep=1pt}
  \rput(1,2){\cnode*{0.15}{root}}
  \rput[cm](1,1){\circlenode{A}{\small $\mathbf{S_1}$}}
  \rput[cm](3,1){\circlenode{B}{\small $\mathbf{S_2}$}}
  \rput[cm](3,3){\circlenode[fillcolor=green]{C}{\small
      $\mathbf{S_3}$}} \rput[cm](3,5){\circlenode{D}{\small
      $S_4$}} \psset{fillcolor=white}
  \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{root}{A}
  
  \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{A}{B}
  \ncput*[fillcolor=white]{\tiny $A_1$}
  \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{B}{C}
  \ncput*[fillcolor=white]{\tiny $R^{\rightarrow}_{(MSG1)}$}
  \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{C}{D}
  \ncput*[fillcolor=white]{\tiny $T^{\leftarrow}_{(MSG2)}$}
\end{pspicture}
\caption[Example state machine]{Example state machine. The state
  machine includes the states $S_{1...4}$ and the transitions
  ($A_1$,
  $R_{(MSG1)}$,$T_{(MSG2)}$).}\label{fig:basic_statemachine}
\end{sidefig}

Special notice must be taken to the state $S_3$. The color of
this state has indicates that this state belongs to some other
state of a more global state machine. If it was a generic
\emph{NFA}, it would normally be understood as the accept state
for the grammar. This is not the case here, since the meaning
can differ and more colors may even be used in the same
drawing. But in any case the meaning of the different colors
will be explained in the accompanied text.

I will in general refer to the transitions as either numbers
which is elaborated somewhere else in the text, or by short
abbreviations of the actions that is causing the transition from
one state to another.

\subsection*{Other figures}
There will of course be other diagrams that reflects the
physical structure of the robot, but they should be self
explaining.

\section{Time}
All communication at least in the node level, is built up around
the time constant $\tau$. This time constant represent the time
it takes to transfer one package in its entirety over the
wire. All timing in the communication is based on multiplies of
this number.

\section{Randomization in modules}
All of the upcoming algorithms are to some extent dependant on a
good randomize function. The reason for this is that in several
occasion a decision is made based on a competition between the
individual modules which implicitly needs a random number to be
generated. In the environment of a simulator, it is easy to
provide a randomized number that is guaranteed to some extent to
be unique. But this is only because that since all the modules
are running in the same shared process which are using the
standard \verb!random! function, they are all using the same
seeding value.

But in the modules, they all have their own seeding value and it
is crucial that all modules do not start with the same seeding
value. If they all started with the same seeding for the
randomize function, there would all run in to problems quite
quickly since non would make any unique behaviour.

\subsection{Whats wrong with random}
There exists several different algorithms to generate random
numbers, where some are mentioned in \cite[Chap
  7]{numerical_recipies}. But even though some of them are
capable of producing some remarkably good randomized sequences,
they all suffer from the problem that they will yield the same
individual sequence of numbers, if they are seeded with the same
value.

In my situation it is not vital to have a ``good'' number
generator since the numbers needed are only integers in limited
ranges.

\subsection{Solution}
Since I, as mentioned, have no need for ``good'' numbers, I will
use the random function from the standard \verb!C! library, This
library, to my knowledge, uses the \emph{Park and Miller variant}
of \verb!random! which is described in \cite[chap 7, sec
  1]{numerical_recipies}.

However in order to guarantee somewhat unique seeding values, I
must rely on external factors to provide this numbering. My idea
basically is to seed the number generator each time a package or
some event happens, with the elapsed time since the module had
been turned on.

All modules suffer of course from the fact that they are powered
on at the very same time. But since there is always some
production hysteresis in the components of the voltage regulator
and the microprocessor, I hope to see that they in fact do not
start at the exact same time and that a slight deviation is
enough to generate a unique enough starting seed.

